'use strict';

import { When, Then, Given } from '@cucumber/cucumber';
import chai from 'chai';
chai.use(require('chai-string'));
const expect = chai.expect;

function sleep(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}

Given(/I am in the project creation dialog/i, async function() {
    await this.overviewPage.loadPage();
    await sleep(1000);
    await this.overviewPage.newProject();
})
Given(/There are no projects/i, async function() {
    let projects = await this.overviewPage.getProjects();
    if (projects.length > 0) {
        throw new Error("There are projects: " + JSON.stringify(projects));
    }
})

When(/I enter valid project metadata with name "([^"]*)"/i, async function(name) {
    await this.overviewPage.enterValidProjectMetadata(name);
})

When(/I exclude the project from the pipeline system/i, async function() {
    await this.overviewPage.excludeProjectFromPipelineSystem();
})

When(/I submit the project/i, async function() {
    await this.overviewPage.submitProject();
})

Then(/I should see the project "([^"]*)"/i, async function(name) {
    await this.overviewPage.waitForProjectToAppear(name);
})
